load ../../Masteroppgave/AIS-data/ais2.csv % Change according to image
prompt = 'Timestamp of image (in Unix Time Stamp): ';
time = input(prompt);


[rows,cols] = size(ais2); % Change according to image
vessels = [zeros(rows,1),ais2]; % Change according to image
vesid = [1,vessels(1,2)];
vessels(1,1)=1;
index=1;


for i=2:rows
    [tempr,tempc]=size(vesid);
    if any(vesid(:)==vessels(i,2));
        for j=1:tempr
            if vesid(j,2)==vessels(i,2)
                vessels(i,1)=vesid(j,1);
            end
        end
    else
        index=index+1;
        vesid = [vesid;index,vessels(i,2)];
        vessels(i,1)=index;
    end
end

[numb,dummy]=size(vesid);
disp(['Number of boats found in area: ' num2str(numb)]);

for breakindex=1:rows
    if vessels(breakindex,3)>=time
        break;
    end
end

before = vessels(1:breakindex-1,:);
after = vessels(breakindex:end,:);

% Searching for an instance of a boat before the image timestamp
ind = length(before(:,1));
checkb=before(:,1);
foundb=false;
if any(checkb(:)==1); % Change according to # boat.
    foundb=true;
    for m=0:ind-1
        if before(ind-m,1)==1 % Change according to # boat
            break;
        end
    end
else
    disp('That boat is not in the before matrix. No data displayed.')
end

if foundb
    disp('The last instance of this boat before is: ');
    disp(['Boat no: ' num2str(before(ind-m,1))]);
    disp(['ID: ' num2str(before(ind-m,2))]);
    timeb=before(ind-m,3);
    disp(['Time: ' num2str(before(ind-m,3))]);
    latb = before(ind-m,4);
    disp(['Latitude: ' num2str(before(ind-m,4))]);
    lonb = before(ind-m,5);
    disp(['Longitude: ' num2str(before(ind-m,5))]);
    disp(['Speed: ' num2str(before(ind-m,6))]);
    disp(['Heading: ' num2str(before(ind-m,7))]);
end

% Searching for an instance of a boat after the image timestamp
ind2 = length(after(:,1));
checka = after(:,1);
founda = false;
if any(checka(:)==1); % Change according to # boat.
    founda = true;
    for m=1:ind2
        if after(m,1)==1 % Change according to boat
            break;
        end
    end
else
    disp('The vessel is not in the after matrix. No data displayed.');
end

if founda
    disp('The last instance of this boat after is: ');
    disp(['Boat no: ' num2str(after(m,1))]);
    disp(['ID: ' num2str(after(m,2))]);
    timea=after(m,3);
    disp(['Time: ' num2str(after(m,3))]);
    lata=after(m,4);
    disp(['Latitude: ' num2str(after(m,4))]);
    lona=after(m,5);
    disp(['Longitude: ' num2str(after(m,5))]);
    disp(['Speed: ' num2str(after(m,6))]);
    disp(['Heading: ' num2str(after(m,7))]);
end

% Interpolation
t = [timeb,timea];
lat = [latb,lata];
lon = [lonb,lona];
new_lat = interp1(t,lat,time);
new_lon = interp1(t,lon,time);

% Finding average speed
R = 6371000; % metres
phi = lat/180*pi;
lambda = lon/180*pi;
deltaphi = (lata-latb)*pi/180;
deltalambda = (lona-lonb)*pi/180;
a = sin(deltaphi/2)*sin(deltaphi/2) + cos(phi(1))*cos(phi(2))*...
    sin(deltalambda/2)*sin(deltalambda/2);
c = 2*atan2(sqrt(a),sqrt(1-a));
d=R*c;

timedif = timea-timeb;
avgspeed = d/timedif; % m/s
avgspeed_k = avgspeed / 0.51444; % knots

if foundb && founda
    disp('After interpolation: ');
    disp([num2str(new_lat) ' ' num2str(new_lon)]);

    disp('Distance traveled (km): ');
    disp(d/1000);

    disp('Average speed (knots): ');
    disp(avgspeed_k);
end