function [image_o,T] = binaryMatrix2(image)

    [rows,cols] = size(image);
    
%     % Segmentation using k-means clustering
%     [mu, clust] = kmeans(image, 3);
%     image_o = zeros(rows,cols);
%     count_c1 = 0;
%     count_c0 = 0;
%     ERROR_c = 0;
% 
% 
%     for i=1:rows
%         for j = 1:cols
%             if clust(i,j) == 1
%                 image_o(i,j) = 0;
%                 count_c1= count_c1+1;
%             elseif clust(i,j) > 1
%                 image_o(i,j) = 1;
%                 count_c0= count_c0+1;
%             else
%                 ERROR_c = 1;
%                 break
%             end
%         end
%     end
    
%     % Global Otsu method

    T = 0.5*(double(min(image(:))) + double(max(image(:))));
    done = false;

    while ~done
        g = image >= T;
        Tnext = 0.5*(mean(image(g)) + mean(image(~g)));
        done = abs(T-Tnext) < 0.5;
        T = Tnext;
    end

    % Processing the image, using the found threshold
    
    % Otsu
    image_o = zeros(rows,cols);
    count_o1 = 0;
    count_o0 = 0;
    ERROR_o = 0;

    for i=1:rows
        for j = 1:cols
            if image(i,j) >= T
                image_o(i,j) = 1;
                count_o1= count_o1+1;
            elseif image(i,j) < T
                image_o(i,j) = 0;
                count_o0= count_o0+1;
            else
                ERROR_o = 1;
                break
            end
        end
    end
end