% Erosion to separate the ice floes
function image = erosion(image, iterations)
    % Checking surrounding pixels for water
        %The smallest floe that can be recorded is a square of side 
        %(2*i_min + 1)pixels, where i_min is # iterations.
    [rows, cols] = size(image);
    ICEcopy=image;
    ICE_ai=image;
    n=0;
    while n<iterations
        for i=2:rows-1
            for j=2:cols-1 
                if ( ICE_ai(i-1,j-1)==0 || ICE_ai(i-1,j)==0 || ICE_ai(i-1,j+1)==0 || ...
                        ICE_ai(i,j+1)==0 || ICE_ai(i+1,j+1)==0 || ICE_ai(i+1,j)==0 || ...
                        ICE_ai(i+1,j-1)==0 || ICE_ai(i,j-1)==0 )
                    ICEcopy(i,j) = 0;
                else
                    ICEcopy(i,j) = 1;
                end
            end
        end
        ICE_ai = ICEcopy;
        n=n+1;
    end
    image = ICE_ai;
end