function [image1] = imageprocsat(image,image_b,constant,T)
    
    image_o = image;

    I2 = imcomplement(image_o);
    I3 = imhmin(I2,T+constant);
    
    L = watershed(I3);
    w = L == 0;
    imageseg = image_b & ~w;

    imageseg = imfill(imageseg,'hole');

    % Watershed transform using the distance transform
    % gc = ~imageseg;
    % D = bwdist(gc);
    % L = watershed(-D);
    % w = L == 0;
    % imageseg = imageseg & ~w;

    % Watershed using gradients
    % h = fspecial('sobel');
    % fd = double(image_o);
    % g = sqrt(imfilter(fd,h,'replicate').^2 + imfilter(fd,h','replicate').^2);
    % L = watershed(g);
    % wr = L == 0;
    % imageseg = image_o & ~wr;

    % Find the cluster sizes
    [clust,numb] = bwlabel(imageseg, 8);
    area = regionprops(clust,'Area');
    cluster_size =  hist(clust(:),0:numb);
    cluster_size = cluster_size(2:end);   %Array representing the icefloe areas
    maxclust = max(cluster_size); % Area of the biggest ice floe.

    % Extract the largest element
    ind = find([area.Area] >= maxclust-500);
%     ind = find([area.Area] >= 10000);
%     Iout = ismember(clust,ind);
%     [clust2,numb2] = bwlabel(Iout, 8);
%     area2 = regionprops(clust2,'Area');
%     ind = find([area2.Area] <= 50000);
%     Iout = ismember(clust2,ind);
    Iout = ismember(clust,ind);
    %image_o = Iout;

    image1 = Iout;

    % Erode if many connecting floes
    %image_o = erosion(image_o,0);

    % Morphology - closing and opening
        R=12;
        se2 = strel('diamond',R);
        se3 = strel('disk',R);
        se4 = strel('octagon',R);

        image2 = imclose(image_o, se2);
        image2 = imopen(image2, se2);

        image3 = imclose(image_o, se3);
        image3 = imopen(image3, se3);

        image4 = imclose(image_o, se4);
        image4 = imopen(image4, se4);

end    