clear all;
display('Note: Images must be called image1, image2 etc., and have the fileformat .png');
prompt = 'Number of images in sequence: ';
seq = input(prompt);
prefix_image='Testimages/track/image';
fileformat='.png';

%deviationstotal = [];

init;
% Load image
for s=2:seq
    
    image = imread(strcat(prefix_image,num2str(s),fileformat));

    % Make grayscale
    if size(image,3)==3
        image = rgb2gray(image);
    end

    % Find dimensions
    [rows,cols] = size(image);
    y = 1:rows;
    x = 1:cols;

    % Making the image into a binary matrix
    [image_o,T] = binaryMatrix2(image);

    % Find and store properties
    [centroids,properties] = characterize(image_o);

    [numb1,def1] = size(properties1); % Numb of objects list
    [numb,def] = size(centroids); % Numb of objects in current image

    % temp = properties;
    match = 0;
    deviations=[];
    for i=1:numb1
        %objectdetected=false;
        area1=properties1(i,1);
        major1=properties1(i,2);
        %minor1=properties1(i,3);
        peri1=properties1(i,5);
        for j=1:numb
            area=properties(j,1);
            if area>=area1*0.99 && area<=area1*1.01
                major=properties(j,2);
                %minor=properties(j,3);
                peri=properties(j,5);
                if (major>=major1*0.99 && major<=major1*1.01) && (peri>=peri1*0.98 && peri<=peri1*1.02)
                    disp(['Successful match between object' num2str(i) ' in image' ...
                        num2str(s-1) ' and object' num2str(j) ' in image' num2str(s)]);
                    %objectdetected = true;
                    match = match + 1;
                    detection(i)=detection(i)+1;
                    properties1(i,6)=1;
                    properties(j,6)=1;
                    %deviations=[deviations;100*(area-area1)/area1,100*(major-major1)/major1,100*(minor-minor1)/minor1,100*(peri-peri1)/peri1];
                end
            end
        end
    end 
    
    %deviationstotal = [deviationstotal;deviations];
    
    new = numb - match;
    notdetect = numb1 - match;
    disp(['Matches: ' num2str(match) ' New objects: ' num2str(new) ...
            ' Not detected from previous: ' num2str(notdetect)]);
        
    % Remove objects not detected
    remove = 0;
    temp = [];
    for k=1:numb1
        if properties1(k,6)==0
            remove = remove +1;
            objectmatch = detection(k);
            temp(remove) = k;
            display(['Object had ' num2str(objectmatch) ' matches before it was removed.']);
        end
    end
    numbrem = length(temp);
    for l=1:numbrem
        properties1(temp(numbrem-l+1),:) = [];
        detection(temp(numbrem-l+1),:) = [];
    end
    
    % Add new objects
    for m=1:numb
        if properties(m,6)==0
            leng = length(properties1);
            properties1(leng+1,:) = properties(m,:);
            detection(leng+1) = 0;
        end
    end
    
    % Clean detection check
   properties1(:,6)=0;
   disp('image successful'); 
end