clear all;
display('Note: Images must be called image1, image2 etc., and have the fileformat .png');
prompt = 'Number of images in sequence: ';
seq = input(prompt);
prefix_image='Testimages/track';
fileformat='.png';

satinit;
% Load image
for s=2:seq
    
    image = imread(strcat(prefix_image,num2str(s),fileformat));

    % Make grayscale
    if size(image,3)==3
        image = rgb2gray(image);
    end

    % Find dimensions
    [rows,cols] = size(image);
    y = 1:rows;
    x = 1:cols;

    % Making the image into a binary matrix
    [image_o,T] = binaryMatrix2(image);
    
    % Image processing
    %image_o = imageproc(image_o,0);
    image_o = imageprocsat(image,image_o,7,T);
    
    % Find and store properties
    [centroids,properties] = satcharacterize(image_o);
    
    image=image_o;
    
    subplot(2,1,1), imshow(image1), title('First image'); 
    subplot(2,1,2), imshow(image), title('Second image'); 
    
    [numb1,def1] = size(properties1); % Numb of objects list
    [numb,def] = size(centroids); % Numb of objects in current image
    
    % temp = properties;
    match = 0;
    flag=0;
    for i=1:numb1
        if flag==1
                break
        end
        %objectdetected=false;
        area1=properties1(i,1);
        major1=properties1(i,2);
        minor1=properties1(i,3);
        peri1=properties1(i,5);
        for j=1:numb
            if flag==1
                break
            end
            peri=properties(j,5);
            if (peri>=peri1*0.15 && peri<=peri1*1.85)
                area=properties(j,1);
                if (area>=area1*0.7 && area<=area1*1.3)
                    major=properties(j,2);
                    minor=properties(j,3);
                    if ((major>=major1*0.9 && major<=major1*1.1)|| ...
                            (minor>=minor1*0.95 && minor<=minor1*1.05))
                        disp(['Successful match between object' num2str(i) ' in image' ...
                            num2str(s-1) ' and object' num2str(j) ' in image' num2str(s)]);
                        match = match + 1;
                        detection(i)=detection(i)+1;
                        properties1(i,6)=1;
                        properties(j,6)=1;
                    end
                end
            end
            if (i==4 && j==1)
                flag=1;
            end
        end
    end
    
    new = numb - match;
    notdetect = numb1 - match;
    disp(['Matches: ' num2str(match) ' New objects: ' num2str(new) ...
            ' Not detected from previous: ' num2str(notdetect)]);
        
    % Remove objects not detected
    remove = 0;
    temp = [];
    for k=1:numb1
        if properties1(k,6)==0
            remove = remove +1;
            objectmatch = detection(k);
            temp(remove) = k;
            display(['Object had ' num2str(objectmatch) ' matches before it was removed.']);
        end
    end
    numbrem = length(temp);
    for l=1:numbrem
        properties1(temp(numbrem-l+1),:) = [];
        detection(temp(numbrem-l+1),:) = [];
    end
    
    % Add new objects
    for m=1:numb
        if properties(m,6)==0
            leng = size(properties1,1);
            properties1(leng+1,:) = properties(m,:);
            detection(leng+1,1) = 0;
        end
    end
    
    % Clean detection check
   properties1(:,6)=0;
   disp('image successful'); 
   
end