%clc 
clear all
parameters

%----Decomposition of the states----%

syms x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 f3 f4; 
x=[x1; x2; x3; x4; x5; x6; x7; x8; x9; x10]; % The states of the system
X_i=[x1 x2]'; % Position in x- and y-direction
V_i=[x3 x4]'; % Velocity in x- and y-direction

%Wind velocity
x5=V_a*cos(theta_a); % x-direction
x6=V_a*sin(theta_a); % y-direction

%Current velocity
x7=V_w*cos(theta_c); % x-direction
x8=V_w*sin(theta_c); % y-direction

% Wave radiation direction and height
x9=a^2*cos(theta_a); % Elevation in x-direction
x10=a^2*sin(theta_a); % Elevation in y-direction

%---- State space model ----%
%U=[1 1 1 1 1 1]'; %Input vector
U=zeros(6,1);

B = [zeros(4,6); eye(6,6)];


% K = 50*[eye(2), zeros(2); zeros(2,4); zeros(2), eye(2); zeros(4)];
% 
% 
% C=[1 0 0 0 0 0 0 0 0 0; 
%     0 1 0 0 0 0 0 0 0 0;
%     0 0 0 0 1 0 0 0 0 0;
%     0 0 0 0 0 1 0 0 0 0
%     0 0 0 0 0 0 1 0 0 0; 
%     0 0 0 0 0 0 0 1 0 0;
%     0 0 0 0 0 0 0 0 1 0;
%     0 0 0 0 0 0 0 0 0 1];

